pipeline  {
	agent any
	
	tools {
        jdk 'OpenJDK8'
    }
    options {
        buildDiscarder(logRotator(numToKeepStr: '5'))
      	gitLabConnection('gitlab.com')
      	gitlabBuilds(builds: ['Resolve Templates', 'Build template', 'Jenkins Build', 'Release', 'Post-Build'])
    }
    triggers {
        gitlab(triggerOnPush: true, triggerOnMergeRequest: true, branchFilterType: 'All')
    }
	post {
      failure {
        updateGitlabCommitStatus name: 'Post-Build', state: 'failed'
      }
      success {
        updateGitlabCommitStatus name: 'Post-Build', state: 'success'
      }
    }
	
    stages {
    	 stage('Build') {
            steps {
                echo "I am building on ${env.BRANCH_NAME}"
                updateGitlabCommitStatus name: 'Jenkins Build', state: 'pending'
				sh "./gradlew clean build --info --stacktrace -Dmaven.repo.local=${WORKSPACE}/.m2"
				updateGitlabCommitStatus name: 'Jenkins Build', state: 'success'
		    }
		}
    	stage('Resolve templates') {
            steps {
                echo "I am building on ${env.BRANCH_NAME}"
                updateGitlabCommitStatus name: 'Resolve Templates', state: 'pending'
				sh "./gradlew resolve.templates --info --stacktrace -Dmaven.repo.local=${WORKSPACE}/.m2"
				updateGitlabCommitStatus name: 'Resolve Templates', state: 'success'
		    }
		}
        stage('Build template') {
            steps {
                echo "I am building on ${env.BRANCH_NAME}"
                updateGitlabCommitStatus name: 'Build template', state: 'pending'
				sh "./gradlew org.gecko.bnd.templates.project.bom:clean org.gecko.bnd.templates.project.bom:build --info"
				updateGitlabCommitStatus name: 'Build template', state: 'success'
		    }
		}
        stage('Master branch release') {
            when { 
            	branch 'master' 
            }
            steps {
	
                echo "I am building on ${env.BRANCH_NAME}"
                updateGitlabCommitStatus name: 'Release', state: 'pending'
				sh "./gradlew clean build release -Drelease.dir=$JENKINS_HOME/repo.gecko/release/geckoBndTemplates/ -x test -x testOSGi --info --stacktrace -Dmaven.repo.local=${WORKSPACE}/.m2"
                sh "mkdir -p $JENKINS_HOME/repo.gecko/release/geckoBndTemplates"
				sh "rm -rf $JENKINS_HOME/repo.gecko/release/geckoBndTemplates/*"
				sh "cp -r cnf/release/* $JENKINS_HOME/repo.gecko/release/geckoBndTemplates"
                updateGitlabCommitStatus name: 'Release', state: 'success'
		    }
		}
        stage('Snapshot branch release') {
            when { 
            	branch 'develop'
            }
            steps  {
                echo "I am building on ${env.JOB_NAME}"
                updateGitlabCommitStatus name: 'Release', state: 'pending'
				sh "./gradlew release --info --stacktrace -Dmaven.repo.local=${WORKSPACE}/.m2"
				sh "mkdir -p $JENKINS_HOME/repo.gecko/snapshot/geckoBndTemplates"
				sh "rm -rf $JENKINS_HOME/repo.gecko/snapshot/geckoBndTemplates/*"
				sh "cp -r cnf/release/* $JENKINS_HOME/repo.gecko/snapshot/geckoBndTemplates"
                updateGitlabCommitStatus name: 'Release', state: 'success'
		    }
		}
		
    }

}
